const zipObject = require('lodash/zipObject');
const isNil = require('lodash/isNil');

const simpleAction = (type, createPayload) => function(...params) {
    return isNil(createPayload)
        ? { type }
        : { type, payload: createPayload(...params) };
}

const namedParameters = (...names) => (...params) => zipObject(names, params);

simpleAction.namedParameters = namedParameters;

module.exports = simpleAction;
